#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################

from AccessControl import ClassSecurityInfo
from Globals import InitializeClass, package_home
from OFS.SimpleItem import SimpleItem
from Products.CMFCore.CMFCorePermissions  import ManagePortal
from Products.CMFCore.utils import UniqueObject, getToolByName
from Products.PageTemplates.PageTemplateFile import PageTemplateFile

from Products.CMFFolder.config import *

class CMFFolderTool(UniqueObject, SimpleItem):
    """ CMFFolder Tool  """ 

    id        = 'cmffolder_tool'
    meta_type = 'CMFFolder Tool'
    security = ClassSecurityInfo()
    plone_tool = 1

    manage_options=(
        ({ 'label'   : 'Config',
           'action'  : 'manage_configForm',
           },
         ) + SimpleItem.manage_options
        )

    security.declareProtected( ManagePortal
                             , 'manage_configForm' )    
    
    manage_configForm = PageTemplateFile('www/config', globals(), __name__='manage_configForm')

    def __init__(self):
        self._reset()

    def _reset(self):
        
        self.MAX_QUOTA_BYTES	= 0
        self.MAX_QUOTA_OBJECTS	= 0
        self.MAX_OBJECT_SIZE	= 0
        self.IS_ALLOW_NESTED	= 1
        self.DISABLE_FOLDERISH_SETTING	= 0
        
        return

    def _set(self, REQUEST=None, **kwargs):
        if REQUEST==None:
            arglist= kwargs
        else:
            arglist = REQUEST
        
        self.DISABLE_FOLDERISH_SETTING	= arglist['DISABLE_FOLDERISH_SETTING']
        if self.DISABLE_FOLDERISH_SETTING:
            self._updateFolders(REQUEST=REQUEST, **kwargs)
    
    def _updateFolders(self, REQUEST=None, **kwargs):
        self.MAX_QUOTA_BYTES	= arglist['MAX_QUOTA_BYTES']
        self.MAX_QUOTA_OBJECTS	= arglist['MAX_QUOTA_OBJECTS']
        self.MAX_OBJECT_SIZE	= arglist['MAX_OBJECT_SIZE']
        self.IS_ALLOW_NESTED	= arglist['IS_ALLOW_NESTED']
        
        items= self.portal_catalog(meta_type='CMFFolder')
        for i in items:
            obj = i.getObject()
            obj.setMax_quota_bytes(self.MAX_QUOTA_BYTES, force=1)
            obj.setMax_quota_objects(self.MAX_QUOTA_OBJECTS, force=1)
            obj.setMax_object_size(self.MAX_OBJECT_SIZE, force=1)
            obj.setIs_allow_nested(self.IS_ALLOW_NESTED)
    
    def manage_configfolder(self, submit, \
                         REQUEST=None, **kwargs):
    
        """config this puppy"""
        if submit == "Update All CMFFolders":
            self._updateFolders(REQUEST=REQUEST, **kwargs)
        elif submit == "Set Config":
            self._set(REQUEST=REQUEST, **kwargs)
        elif submit == "Reset Config":
            self._reset()
    
        if REQUEST:
            return REQUEST.RESPONSE.redirect(self.absolute_url() + \
                                             "/manage_configForm?portal_status_message=Config+Updated")
    

InitializeClass(CMFFolderTool)
